"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var di_1 = require("@asuka/di");
var omit_1 = tslib_1.__importDefault(require("lodash/omit"));
var configSets = new Set();
exports.Module = function (config) {
    var injectableConfig = { providers: [] };
    var name;
    if (typeof config === 'string') {
        if (configSets.has(config)) {
            throw new Error("Duplicated Module name: " + config);
        }
        name = config;
        configSets.add(config);
    }
    else if (config && typeof config.name === 'string') {
        if (configSets.has(config.name)) {
            throw new Error("Duplicated Module name: " + config.name);
        }
        configSets.add(config.name);
        name = config.name;
        Object.assign(injectableConfig, omit_1.default(config, 'name'));
    }
    else {
        throw new TypeError('config in Module type error, support string or InjectableConfig with name');
    }
    return function (target) {
        target.prototype.moduleName = name;
        return di_1.Injectable(injectableConfig)(target);
    };
};
