"use strict";
/* istanbul ignore next */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var noop_1 = tslib_1.__importDefault(require("lodash/noop"));
var terminate_1 = require("./ssr/terminate");
var devtool = {
    send: noop_1.default,
    init: noop_1.default,
};
var FakeReduxDevTools = {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    connect: function () { return devtool; },
};
exports.INIT_ACTION_TYPE = 'INIT_AYANAMI_STATE';
var ReduxDevTools = (typeof window !== 'undefined' && window.__REDUX_DEVTOOLS_EXTENSION__) ||
    FakeReduxDevTools;
var STATE = {};
exports.logStateAction = function (action) {
    var _a;
    if (action.type === terminate_1.TERMINATE_ACTION.type) {
        return;
    }
    var namespace = action.state.name;
    var _action = {
        type: namespace + "/" + String(action.type),
        params: filterParams(action.payload),
    };
    STATE[namespace] = action.state.getState();
    if (!((_a = action.type) === null || _a === void 0 ? void 0 : _a.endsWith(exports.INIT_ACTION_TYPE))) {
        devtool.send(_action, STATE);
    }
};
if (process.env.NODE_ENV !== 'development') {
    exports.logStateAction = noop_1.default;
}
exports.initDevtool = function () {
    if (process.env.NODE_ENV === 'development') {
        devtool = ReduxDevTools.connect({
            name: "Ayanami",
        });
        devtool.init(STATE);
    }
};
function filterParams(params) {
    if (params && typeof params === 'object') {
        if (params instanceof Event) {
            return "<<Event:" + params.type + ">>";
        }
        else if (params.nativeEvent instanceof Event) {
            return "<<SyntheticEvent:" + params.nativeEvent.type + ">>";
        }
    }
    return params;
}
